int linearSearch(int list[], int n, int e) {
   int location = -1;
   int i = 0;
   int found = 0;

   while( !found && i<n ) {
      if(list[i] == e) {
          location = i;
          found = 1;           
      } else {
          i++;       
      }
   }
    
   return location;
 }
 
int optimizedLinearSearch(int list[], int n, int e) {
   int location = -1;
   int i = 0;
   int found = 0;

   while( !found && i<n && list[i]<=e) {
       if(list[i] == e) {
           location = i;
           found = 1;
       } else {
           i++;
       }
   }

    return location;
}

int binarySearch(int list[], int n, int e) {
   int location = -1;
   int left = 0;
   int right = n-1;
   int middle = (left+right) / 2;
   int found = 0;
   
   while( left <= right && !found) {
      if(list[middle] == e) {
           found = 1;
           location = middle;
      } else {
           if(e < list[middle])
               right = middle-1;
           else
               left = middle + 1;
               
           middle = (left + right) / 2;
      }
   }
    
   return location;
}
